//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: pThreads parallel programming methods
//     
//      pThreads01.c: my First program
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      gcc pThreads01.c -o pThreads01 -lpthread
Executing:      ./pThreads01 
Output in my laptop:

Main: Before Thread
Main: After Thread
myThread1: Inside Thread
Main: Thread is terminated
*********************************************************************
*/

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>   
#include <pthread.h> 
  
// *********************************************************************
//      the function executed in a thread ....
// *********************************************************************
void *myThread1(void *vargp) 
{ 
    sleep(1); 
    printf("myThread1: Inside Thread\n"); 
    return NULL; 
} 
   
// *********************************************************************
int main() 
{ 
    pthread_t tid; 

    printf("Main: Before Thread\n"); 
    pthread_create(&tid, NULL, myThread1, NULL); 
    printf("Main: After Thread\n"); 
    pthread_join(tid, NULL); 
    printf("Main: Thread is terminated\n"); 
    exit(0); 
}
