//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: pThreads parallel programming methods
//     
//      pThreads02.c: my Second program, passing parameters 
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      gcc pThreads02.c -o pThreads02 -lpthread
Executing:      ./pThreads02
Output in my Laptop:
Main: Before Thread
Thread: Printing 0
Thread: Printing 1
Thread: Printing 2
Main: After Thread

*********************************************************************
*/

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>  //Header file for usleep()
#include <pthread.h> 
  
//************************************************************
void *myThread2(void *varp) 
{ 
	int q = 0, k ;

 	q = *((int *) varp) ;
//    usleep(1000); 
    printf("Thread: Printing %d\n", q);
//    scanf("%d",&k) ; 
    return NULL; 
} 


//************************************************************
int main() 
{ 
    pthread_t tid; 
    
    int j ;
    printf("Main: Before Thread\n"); 
    for(  j = 0 ; j < 3 ; j++ ) { 
    	pthread_create(&tid, NULL, myThread2, (void *) (&j)); 
    	pthread_join(tid, NULL);
    } 
    printf("Main: After Thread\n"); 
    exit(0); 
}

